/*Na ulazu se zadaje ceo broj N a zatim N Fajlova. Elementi strukture Fajl su NAZIV_FAJLA(jedna
reč), VELICINA_FAJLA(realan broj) i EKSTENZIJA(jedna reč). Formirati binarno stablo čiji su
elementi Fajlovi i koje je uređeno u odnosu na VELICINA_FAJLA. Ispisati Fajlove ali tako da se
prvo ispišu fajlovi najveće veličine. Za unetu ekstenziju EKS i veličinu fajla VL od formiranog
binarnog stabla formirati novo uređeno po istom kriterijumu ali koje sadrži samo one čvore
prvog stabla koji su date ekstenzije i veličina im je veća od unete veličine VL. Ispisati
novoformirano stablo od fajlova najveće veličine.
NAPOMENA: Maksimalan broj poena se dobija ukoliko se optimizuje obilazak stabla.*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct s
{
	char *ime;
	int velicina;
	char *ekstenzija;
	struct s *levi;
	struct s *desni;
} stablo;

#define novi(x) x=(stablo*)malloc(sizeof(stablo))
#define novic(x,s) x=(char*)malloc(strlen(s)+ 1)

void Ispis (stablo *p)
{
	if (p)
	{
		if (p->desni) Ispis(p->desni);
		printf("naziv = %s\t, velicina = %d\t, ekstenzija = %s\n", p->ime, p->velicina, p->ekstenzija);
		if (p->levi) Ispis(p->levi);
	}
}	 

stablo* Ubaci(stablo *p, char *ime, int velicina, char *ekstenzija)
{
	stablo *q=NULL, *pom=p, *prepom=NULL;
	
	novi(q);
	novic(q->ime, ime);
	strcpy(q->ime, ime);
	novic(q->ekstenzija, ekstenzija);
	novic(q->ekstenzija, ekstenzija);
	q->velicina=velicina;
	q->levi=q->desni=NULL;
	
	if (p==NULL) p=q;
	else
	{
		while (pom)
		{
			prepom=pom;
			if (velicina >= pom->velicina) pom=pom->desni;
			else pom=pom->levi;
		}
		
		if (velicina >= prepom->velicina) prepom->desni=q;
		else prepom->levi=q;
	}
	return p;
}

stablo* Formiraj (stablo *p, FILE *f)
{
	int i, n, v;
	char ime[100], ekstenzija[20];
	
	fscanf(f, "%d", &n);

	
	for (i=0; i<n; i++)
	{
//		fscanf(f, "%s %d %s", ime, &v, ekstenzija);
//		printf("%s %d %s", ime, v, ekstenzija);
		fscanf(f, "%s", ime);
		fscanf(f, "%d", &v);
		fscanf(f, "%s", ekstenzija);
		p=Ubaci(p, ime, v, ekstenzija);
	}
	return p;
}


void Novo_stablo (stablo *p, stablo **q, char *e, int velicina)
{
	if (p)
	{
	//	if (p->velicina>velicina){
		if ((strcmp(p->ekstenzija, e)) == 0 && p->velicina > velicina) 
		{
			(*q)=Ubaci(*q, p->ime, p->velicina, p->ekstenzija);
		//	if (p->levi) Novo_stablo(p->levi, q, e, velicina);
		//	if (p->desni) Novo_stablo(p->levi, q, e, velicina);
		}
		if (p->levi) Novo_stablo(p->levi, q, e, velicina);
	    if (p->desni) Novo_stablo(p->levi, q, e, velicina);
	}
}

int main (int argc, char *argv[])
{
	FILE *f=fopen(argv[1], "r");
	stablo *p=NULL, *q=NULL;
	int v;
	char e[50];
	p=Formiraj(p, f);
	fclose(f);
	if (p)
	{
		Ispis(p);
		printf("Unesi ekstenziju i velicinu\n");
		scanf("%s", e);
		scanf("%d", &v);
		Novo_stablo(p, &q, e, v);
		Ispis(q);
	}
	else printf("Stablo je prazno \n");
	return 0;

}
