/*
 * Tramvaj broj 2 koji kruži “u krugu dvojke” ima N stajališta (N se zadaje na ulazu).
 *
 * Tramvaj sa početnog stajališta kreće bez putnika (prazan).
 *
 * Za svako stajalište se unose
 *      NAZIV(jedna reč),
        ULAZ(broj putnika koji ulaze – ceo broj) i
        IZLAZ(broj putnika koji izlaze – ceo broj).

Napraviti kružnu povezanu listu, koja predstavlja trasu tramvaja broj 2, pri čemu putnici uvek mogu da uđu
u tramvaj, ali ukoliko se navede da na datom stajalištu izlazi više putnika nego što trenutno
postoji u tramvaju, tada izlaze svi putnici.

Svaki element liste odgovara jednom stajalištu i sadrži

    NAZIV stajališta i
    BROJ putnika u tramvaju u trenutku kada tramvaj kreće sa tog stajališta.

Ispisati trasu tramvaja broj 2 sa podacima NAZIV stajališta i BROJ putnika.


Tramvaj nastavlja da kruži, i za svako trenutno stajalište se ponovo unose samo brojevi putnika
(bez naziva stajališta) koji ulaze i koji izlaze iz tramvaja.

Ukoliko na nekom stajalištu niko ne uđe i ne izađe u sledećim prolascima na tom stajalištu tramvaj ne staje. Tramvaj kruži bez prestanka
sve dok ne ostane samo jedno stajalište na kom završava svoju smenu i svi putnici koji se nalaze u
tom trenutku u tramvaju izlaze iz njega.

Nakon svakog kruga (kad god tramvaj stigne do polaznog stajališta) ispisati trasu tramvaja.

NAPOMENA: Smatra se da će tramvaj u nekom trenutku sigurno završiti smenu.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct Stanica
{
    char *naziv;
    int broj;
    struct Stanica *sledeci;
};



struct Stanica *Dodaj(struct Stanica *p, char *naziv, int ulaz, int izlaz)
{
    struct Stanica *novi;

    novi = (struct Stanica *) malloc (sizeof(struct Stanica));
    if(novi == NULL)
    {
        printf("Greska\n");
        exit(0);
    }

    novi ->naziv = (char *) malloc (strlen (naziv) +1);
    strcpy(novi->naziv , naziv);


    if(p == NULL)
    {
        novi ->sledeci = novi;
        novi->broj = ulaz; // bio je przan
        p = novi;
    }
    else
    {
        struct Stanica *pom;
        pom = p;
        while(pom ->sledeci != p)
            pom = pom->sledeci;

        pom->sledeci = novi;
        if(pom->broj < izlaz)
                novi->broj = ulaz; // prethodni izadju, pa je broj samo novih putnika
        else
            novi->broj = pom->broj - izlaz +ulaz;

        novi->sledeci = p;
    }

    return p;
}


struct Stanica *Ucitaj()
{
    struct Stanica *p = NULL;
    char s[50];
    int i, n, ulaz, izlaz;
    printf("Unesite n: ");
    scanf("%d",&n);
    for(i=0;i<n;i++)
    {
        printf("\n\nUnesite ime stanice: ");
        scanf("%s",s);
        printf("Unesite ulaz: ");
        scanf("%d",&ulaz);
        printf("Unesite izlaz: ");
        scanf("%d",&izlaz);

        p = Dodaj(p,s,ulaz,izlaz);
    }

    return  p;

}


void pisi (struct Stanica *p)
{
    if(p == NULL)
    {
        printf("Lista je prazna\n");

    } pret = pom1;
    while(pret->sledeci != pom1)
        pret = pret->sledeci;

    else
    {
        struct Stanica *pom;
        pom = p;
        do
        {
            printf("%s \t %d\n",pom->naziv, pom->broj);
            pom = pom ->sledeci;

        }while(pom!=p);

        printf("\n\n");
    }
}

struct Stanica * Kruzi (struct Stanica *p)
{
    int i, n, ulaz, izlaz;
    struct Stanica *pom1, *pret, *obrisi;
    pom1 = p;
    pret = pom1;
    while(pret->sledeci != pom1)
        pret = pret->sledeci;

    while(pom1 != pom1 ->sledeci)
    {
        for(i=0;i<n;i++)
        {
            printf("\n\nime stanice %s ",pom1->naziv);

            printf("Unesite ulaz: ");
            scanf("%d",&ulaz);
            printf("Unesite izlaz: ");
            scanf("%d",&izlaz);

            if(pret->broj < izlaz)
                    pom1->broj = ulaz; // prethodni izadju, pa je broj samo novih putnika
            else
                pom1->broj = pret->broj - izlaz +ulaz;



            if( ulaz == 0 && izlaz == 0)
            {
                // brisi pom
                obrisi = pom1;
                pret->sledeci = pom1->sledeci
                if(p == pom1)
                        p = p->sledeci;
                free(obrisi);

            }
            else
            {
                pret = pom1;
                pom1 = pom1->sledeci;
            }


        }


        pisi(p); pret = pom1;
        while(pret->sledeci != pom1)
            pret = pret->sledeci;

    }

    return p;
}

main()
{
    struct Stanica *p;
    p = Ucitaj();
    pisi(p);
    p = Kruzi(p);
}

