#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Fajl
{
	char naziv[20];
	float velicina;
	char ekstenzija[10];
} Fajl;

typedef struct stablo
{
	Fajl fajl;
	struct stablo *levi,*desni;
} stablo;

#define aloc(x) x=(stablo*)malloc(sizeof(stablo))

void dodaj(stablo **p,Fajl x);
void formiraj(stablo **p,char dat[]);
void stampaj(stablo *p);
void novo_stablo(stablo *p,stablo **q,float VL,char EKS[]);

int main(int argc, char *argv[])
{
	if(argc!=2)
	{
		printf("Greska! Upotreba: %s ime_datoteke\n",argv[0]);
		exit (1);
	}
	
	stablo *p=NULL,*q=NULL;
	
	formiraj(&p,argv[1]);
	printf("\nStablo:\n");
	stampaj(p);
	
	
	float VL;
	char EKS[50];
	printf("Unesite ekstenziju i velicinu: ");
	scanf("%s%f",EKS,&VL);
	novo_stablo(p,&q,VL,EKS);
	printf("\nNovo stablo:\n");
	stampaj(q);
}

void dodaj(stablo **p,Fajl x)
{
	stablo *t,*pom1,*pom2;
	
	aloc(t);
	t->fajl=x;
	t->levi=t->desni=NULL;
	
	if(*p==NULL) *p=t;
	else
	{
		pom1=*p;
		while(pom1)
		{
			pom2=pom1;
			if(x.velicina<pom1->fajl.velicina) pom1=pom1->levi;
			else pom1=pom1->desni;
		}
		if(x.velicina<pom2->fajl.velicina) pom2->levi=t;
		else pom2->desni=t;
	}
}
	
void formiraj(stablo **p,char dat[])
{
	FILE *f=fopen(dat,"r");
	if(!f)
	{
		printf("Greska prilikom ucitavanja datoteke!\n");
		exit(1);
	}
	
	Fajl x;
	int n,i;
	fscanf(f,"%d",&n);
	
	for(i=0;i<n;i++)
	{
		fscanf(f,"%s%f%s",x.naziv,&x.velicina,x.ekstenzija);
		dodaj(p,x);
	}
	
	fclose(f);
}
	
void stampaj(stablo *p)
{
	if(p)
	{
		if(p->desni) stampaj(p->desni);
		printf("%s.%s %.2f\n",p->fajl.naziv,p->fajl.ekstenzija,p->fajl.velicina);
		if(p->levi) stampaj(p->levi);
	}
}

void novo_stablo(stablo *p,stablo **q,float VL,char EKS[])
{
	if(p)
	{
		if(p->fajl.velicina<VL) novo_stablo(p->desni,q,VL,EKS);
		else
		{
			if(!strcmp(p->fajl.ekstenzija,EKS)) dodaj(q,p->fajl);
			novo_stablo(p->desni,q,VL,EKS);
			novo_stablo(p->levi,q,VL,EKS);
		}
	}
}
	
	
		
