#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*	Na ulazu se zadaje ceo broj N a zatim N Fajlova. Elementi strukture Fajl su NAZIV_FAJLA(jedna
	reč), VELICINA_FAJLA(realan broj) i EKSTENZIJA(jedna reč). Formirati binarno stablo čiji su
	elementi Fajlovi i koje je uređeno u odnosu na VELICINA_FAJLA. Ispisati Fajlove ali tako da se
	prvo ispišu fajlovi najveće veličine. Za unetu ekstenziju EKS i veličinu fajla VL od formiranog
	binarnog stabla formirati novo uređeno po istom kriterijumu ali koje sadrži samo one čvore
	prvog stabla koji su date ekstenzije i veličina im je veća od unete veličine VL. Ispisati
	novoformirano stablo od fajlova najveće veličine.
	NAPOMENA: Maksimalan broj poena se dobija ukoliko se optimizuje obilazak stabla.					*/
	
typedef struct node_s {
	char NAZIV_FAJLA[20];
	double VELICINA_FAJLA;
	char EKSTENZIJA[20];
	struct node_s *left, *right;
} node;

#define new(x) x=(node*)malloc(sizeof(node))

void Add(node **p, char naziv[], double velicina, char ekst[]) {
	node*temp;
	new(temp);
	
	strcpy(temp->NAZIV_FAJLA,naziv);
	temp->VELICINA_FAJLA = velicina;
	strcpy(temp->EKSTENZIJA,ekst);
	temp->left = temp->right = NULL;
	
	if (*p == NULL) {
		*p = temp;
	} else {
		node *pom1, *pom2;
		pom1 = *p;
		
		while(pom1) {
			pom2 = pom1;
			if (velicina < pom1->VELICINA_FAJLA)
				pom1 = pom1 -> left;
			else 
				pom1 = pom1 -> right;
		}
		
		if (velicina < pom2->VELICINA_FAJLA)
			pom2 -> left = temp;
		else
			pom2 -> right = temp;
	}
	
}

/* Ispisati Fajlove ali tako da se
   prvo ispišu fajlovi najveće veličine */
   
void PrintTree(node *p) {
	if (p) {
		PrintTree(p->right);
		printf("%s %lf %s\n",p->NAZIV_FAJLA,p->VELICINA_FAJLA,p->EKSTENZIJA);
		PrintTree(p->left);
	}
}

void PrintTreeInOrder(node *p) {
	if (p) {
		PrintTree(p->left);
		printf("%s %lf %s\n",p->NAZIV_FAJLA,p->VELICINA_FAJLA,p->EKSTENZIJA);
		PrintTree(p->right);
	}
}

node* FormTree() {
	int n;
	printf("n: ");
	scanf("%d",&n);
	char naziv[20];
	double velicina;
	char ekst[20];
	
	node *root = NULL;
	
	for(;n;n--) {
		scanf("%s",naziv);
		scanf("%lf",&velicina);
		scanf("%s",ekst);
		Add(&root,naziv,velicina,ekst);
	}
	
	return root;
}


/*	Za unetu ekstenziju EKS i veličinu fajla VL od formiranog
	binarnog stabla formirati novo uređeno po istom kriterijumu ali koje sadrži samo one čvore
	prvog stabla koji su date ekstenzije i veličina im je veća od unete veličine VL				*/


void change(node *p,node **new, char EKS[], double VL) {
	if(p) {
		 if ( (!strcmp(EKS,p->EKSTENZIJA)) && (p->VELICINA_FAJLA > VL) )
			Add(new, p->NAZIV_FAJLA, p->VELICINA_FAJLA, p->EKSTENZIJA);
		 
		 if (p->left->VELICINA_FAJLA > VL) change(p->left,new,EKS,VL);
		 if (p->right) change(p->right,new,EKS,VL);
	 }	
}

int main(void) {
	node *root1 = FormTree();
	node *root2;
	
	printf("\n");
	
	PrintTree(root1);
	
	char EKS[20];
	double VL;
	
	//scanf("%s%lf",EKS,&VL);
	
	//change(root1,&root2,EKS,VL);
	
	//printf("\nNovo stablo:\n");
	
	//PrintTree(root2);
	
	
	
	return 0;
}



		
		
		
		
		
		
		
		
