#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*	Tramvaj broj 2 koji kruži “u krugu dvojke” ima N stajališta (N se zadaje na ulazu). Tramvaj sa
	početnog stajališta kreće bez putnika (prazan). Za svako stajalište se unose NAZIV(jedna reč),
	ULAZ(broj putnika koji ulaze – ceo broj) i IZLAZ(broj putnika koji izlaze – ceo broj). Napraviti
	kružnu povezanu listu, koja predstavlja trasu tramvaja broj 2, pri čemu putnici uvek mogu da uđu
	u tramvaj, ali ukoliko se navede da na datom stajalištu izlazi više putnika nego što trenutno
	postoji u tramvaju, tada izlaze svi putnici. Svaki element liste odgovara jednom stajalištu i sadrži
	NAZIV stajališta i BROJ putnika u tramvaju u trenutku kada tramvaj kreće sa tog stajališta. Ispisati
	trasu tramvaja broj 2 sa podacima NAZIV stajališta i BROJ putnika.

	Tramvaj nastavlja da kruži, i za svako trenutno stajalište se ponovo unose samo brojevi putnika
	(bez naziva stajališta) koji ulaze i koji izlaze iz tramvaja. Ukoliko na nekom stajalištu niko ne uđe i
	ne izađe u sledećim prolascima na tom stajalištu tramvaj ne staje. Tramvaj kruži bez prestanka
	sve dok ne ostane samo jedno stajalište na kom završava svoju smenu i svi putnici koji se nalaze u
	tom trenutku u tramvaju izlaze iz njega. Nakon svakog kruga (kad god tramvaj stigne do polaznog
	stajališta) ispisati trasu tramvaja.
	NAPOMENA: Smatra se da će tramvaj u nekom trenutku sigurno završiti smenu.										*/


typedef struct lista_s {
	char NAZIV[20];
	int ULAZ;
	int IZLAZ;
	int BROJ_PUTNIKA;
	int IZBACEN;
	struct lista_s *rep;
} lista;

#define new(x) x=(lista*)malloc(sizeof(lista))

void Add(lista **p, char naziv[], int ulaz, int izlaz) {
	lista *temp = new(temp);
	strcpy(temp->NAZIV,naziv);
	temp->ULAZ = ulaz;
	temp->IZLAZ = izlaz;
	temp->IZBACEN = 0;
	
	
	if (*p == NULL) {
		temp->rep = temp;
		*p = temp;
	} else {
		lista *tren, *poc;
		poc  = *p;
		tren = *p;
		
		while(tren->rep != poc)
			tren = tren->rep;
		
		temp->rep = tren->rep;
		tren->rep = temp;
	}
	
}

lista* FormList() {
	int n;
	printf("\nn: ");
	scanf("%d",&n);
	lista *p = NULL;
	
	char naziv[20];
	int ulaz,izlaz;
	
	for(;n;n--) {
		scanf("%s%d%d",naziv,&ulaz,&izlaz);
		Add(&p,naziv,ulaz,izlaz);
	}
	
	return p;
}

/*	Napraviti
	kružnu povezanu listu, koja predstavlja trasu tramvaja broj 2, pri čemu putnici uvek mogu da uđu
	u tramvaj, ali ukoliko se navede da na datom stajalištu izlazi više putnika nego što trenutno
	postoji u tramvaju, tada izlaze svi putnici. Svaki element liste odgovara jednom stajalištu i sadrži
	NAZIV stajališta i BROJ putnika u tramvaju u trenutku kada tramvaj kreće sa tog stajališta. Ispisati
	trasu tramvaja broj 2 sa podacima NAZIV stajališta i BROJ putnika.										*/
	
void trasa1(lista **p) {
	lista *poc, *tren;
	
	poc = *p;
	tren = *p;
	int bp = 0;
	
	do {
		if (tren->IZLAZ > bp){
			bp = 0;
			bp += tren->ULAZ;}
		else {
			bp -= tren->IZLAZ;
			bp += tren->ULAZ;
		}
		tren->BROJ_PUTNIKA = bp;	
		
		tren = tren->rep;
			
	}while(tren!=poc);
	
}

void ispis1(lista *p){
	if(p){
		lista *tren = p;
		do{
			printf("%s %d\n",tren->NAZIV, tren->BROJ_PUTNIKA);
			tren = tren ->rep;		
			
		}while(tren != p);
		
	} else {
		printf("\nLista je prazna\n");
		
	}
}


/*	Tramvaj nastavlja da kruži, i za svako trenutno stajalište se ponovo unose samo brojevi putnika
	(bez naziva stajališta) koji ulaze i koji izlaze iz tramvaja. Ukoliko na nekom stajalištu niko ne uđe i
	ne izađe u sledećim prolascima na tom stajalištu tramvaj ne staje. Tramvaj kruži bez prestanka
	sve dok ne ostane samo jedno stajalište na kom završava svoju smenu i svi putnici koji se nalaze u
	tom trenutku u tramvaju izlaze iz njega. Nakon svakog kruga (kad god tramvaj stigne do polaznog
	stajališta) ispisati trasu tramvaja.
	NAPOMENA: Smatra se da će tramvaj u nekom trenutku sigurno završiti smenu.									*/


int samo_1_ostao(lista *p) {
	int br = 0;
	
	lista *tren, *poc;
	
	tren = poc = p;
	do {
		if (tren->IZBACEN == 0)
			br++;
	}while(tren!=poc);
	
	
	
	if (br==1)	
		return 1;
	else 
		return 0;
	
}

void trasa2(lista **p) {
	int ulaz, izlaz;
	lista *tren = *p;
	
	//ostace samo jedno stajaliste ako na ostala ne ide 
	// tj za ta ostala su ranije uneti ulaz 0 i izla 0 ??/??
	// izbacen == 0 nije izbacen
	
	while(samo_1_ostao(*p) == 0) {
		scanf("%d%d",&ulaz, &izlaz);
		
		if (ulaz == 0 && izlaz == 0) {
			tren = tren->rep;
		} else {
			if ( izlaz > tren->BROJ_PUTNIKA){
			tren->BROJ_PUTNIKA = 0;
			tren->BROJ_PUTNIKA += ulaz;
			tren = tren->rep;
		}  else {
			tren->BROJ_PUTNIKA -= izlaz;
			tren->BROJ_PUTNIKA += ulaz;
			tren = tren->rep;
		}
	    
	    }
	   
	}
	
}
	
			

		
	
	
	
	
	
	
			








int main(void) {
	
	lista *p = FormList();
	
	trasa1(&p);
	
	printf("\nNakon prvog prolaska: \n");
	
	ispis1(p);
	
	
	
	
	
	
	
	
	
	
	
	return 0;
}
	
	
	
	
	
	
	
	
	
